package cz.fi.muni.pa165.entity;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.Set;
import java.util.UUID;

/**
 * @author David Sapák
 */
@Getter
@Setter
@AllArgsConstructor
@Entity
public class Album {

    @Id
    @NotNull
    private String id = UUID.randomUUID().toString();

    @NotNull
    @Column(nullable = false)
    private String name;

    @OneToMany(mappedBy = "album")
    private Set<Song> songs;

    @ManyToOne
    @JoinColumn(name = "band_id")
    private Band band;

    public Album(){}

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null)
            return false;
        if (!(o instanceof Album))
            return false;
        Album album = (Album) o;
        return getId().equals(album.getId());
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (getId() != null ? getId().hashCode() : 0);
        return result;
    }


    @Override
    public String toString() {
        return "Album{" +
                "id=" + id +
                ", name='" + name + '\'' +
                ", songs=" + songs +
                '}';
    }

    public void addSong(Song song) {
        songs.add(song);
    }
}
