import axios from 'axios'

const ACTIVITY_URL = 'http://localhost:8083/pa165/rest/activity'

class ActivityService {
    async getActivities() {
        return axios.get(ACTIVITY_URL, {
            headers: {
                'Access-Control-Allow-Origin': '*',
                'Accept': 'application/json'
            }
        });
    }

    async delete(activityId){
        await this.send("delete", "/delete", {id: activityId})
    }

    async send(method, url, body){
        await axios({
            headers: {
                "Accept": "application/json",
                "Content-Type": "application/json",
              },
            method: method,
            url: ACTIVITY_URL + url,
            data: JSON.stringify(body)
        });
    }

    async update(idParam, name, timeParam, band) {
        const body = {id: idParam, name: name, time: timeParam, bandId: band};
        await this.send('put', '/update', body)
    }

    async createActivity(name, timeParam, band) {
        const body = {name: name, time: timeParam, bandId: band};
        await this.send('POST', '/create', body)
    }
}

export default new ActivityService();
