import axios from 'axios'

const BAND_URL = 'http://localhost:8083/pa165/rest/band'

class BandService {
    async update(paramId, nameParam, bandTypeParama, logoParama, bandMembersParam){
        bandMembersParam = ["0"]
        const body = {
            id: paramId,
            name: nameParam,
            bandType: bandTypeParama,
            logo: logoParama,
            bandMembers: bandMembersParam
        }
        await this.send("put", "/update", body)
    }

    async create(nameParam, bandTypeParama, logoParama, bandMembersParam){
        bandMembersParam = []
        const body = {
            name: nameParam,
            logo: logoParama,
            bandType: bandTypeParama,
            bandMembers: bandMembersParam
        }
        await this.send("post", "/create", body)
    }

    async getBands() {
        return await axios.get(BAND_URL, {
            headers: {
                'Access-Control-Allow-Origin': '*',
                'Accept': 'application/json'
            }
        });
    }

    async getBandById(bandId){
        return axios.get(BAND_URL+"/"+bandId, {
            headers: {
                'Access-Control-Allow-Origin': '*',
                'Accept': 'application/json'
            }
        });
    }

    async send(method, url, body){
        await axios({
            headers: {
                "Accept" : "application/json",
                "Content-Type": "application/json",
              },
            method: method,
            url: BAND_URL + url,
            data: JSON.stringify(body)
        });
    }
}

export default new BandService();
