import axios from 'axios'

const MUS_URL = 'http://localhost:8083/pa165/rest/musicians'

class MusiciansService {
    async createMusicains(nameParam, musicianTypeParama, bandIdParam){
        const body = {name : nameParam, musicianType  : musicianTypeParama, bandId : bandIdParam};
        await this.send('post', '/create', body)
    }

    async delete(id){
        await this.send('delete', '/delete/' + id, null)
    }

    async getMusiciansBand(id) {
        const url =`/${id}/musicians_bands`
        await this.send('get', url, null)
    }

    async upadate(paramId, nameParam, musicianTypeParama, bandIdParam){
        const body = {id: paramId, name : nameParam, musicianType  : musicianTypeParama, bandId : bandIdParam}
        await this.send("put", "/update", body)
    }

    async getsMusicians() {
        return axios.get(MUS_URL, {
            headers: {
                'Access-Control-Allow-Origin': '*',
                'Accept': 'application/json'
            }
        });
    }

    async acceptOffer(musicianId, offerId){
        const url =`/${offerId}/accept_offer/${musicianId}`
        await this.send("put", url, null)
    }

    async send(method, url, body){
        await axios({
            headers: {
                "Accept": "application/json",
                "Access-Control-Allow-Origin": "*",
                "Content-Type": "application/json",
              },
            method: method,
            url: MUS_URL + url,
            data: JSON.stringify(body)
        });
    }
}

export default new MusiciansService();
