import axios from 'axios'

const OFFER_URL = 'http://localhost:8083/pa165/rest/offer'

class OfferService {
    async getOffers() {
        return axios.get(OFFER_URL, {
            headers: {
                'Access-Control-Allow-Origin': '*',
                'Accept': 'application/json'
            }
        });
    }

    async createOffer(nameParam, bandIdParam){
        const body = {name : nameParam, bandId : bandIdParam};
        await this.send("post", '/create', body)
    }

    async update(offerId, offerName, offerBandId){
        const body = {
            id: offerId,
            name: offerName,
            bandId: offerBandId
        }
        await this.send("put", "/update", body)
    }

    async delete(offerId){
        await this.send("delete", "/delete", {id:offerId})
    }

    async send(method, url, body){
        await axios({
            headers: {
                "Accept" : "application/json",
                "Content-Type": "application/json",
                'Access-Control-Allow-Origin': '*',
              },
            method: method,
            url: OFFER_URL + url,
            data: JSON.stringify(body),
        });
    }
}

export default new OfferService();
