import axios from 'axios'

const SONG_URL = 'http://localhost:8083/pa165/rest/song'

class SongService {
    async create(nameParam, durationPara, albumIdParam){
        const body = {songName : nameParam, duration: parseInt(durationPara), albumId: albumIdParam}
        await this.send("post", "/create", body)
    }

    async update(songId, nameParam, durationPara, albumIdParam){
        const body = {id: songId, songName : nameParam, duration: parseInt(durationPara), albumId: albumIdParam}
        await this.send("put", "/update", body)
    }

    async delete(songId){
        await this.send("delete", "/delete", {id: songId})
    }

    async getSongs() {
        return axios.get(SONG_URL, {
            headers: {
                'Access-Control-Allow-Origin': '*',
                'Accept': 'application/json'
            }
        });
    }

    async send(method, url, body){
        await axios({
            headers: {
                "Accept": "application/json",
                'Access-Control-Allow-Origin': '*',
                "Content-Type": "application/json",
              },
            method: method,
            url: SONG_URL + url,
            data: JSON.stringify(body)
        });
    }
}

export default new SongService();